# include <bits/stdc++.h>

using namespace std;

long long A[75000];
long long B[75000];
int C[5];

int razlika(long long A[], int n)
{
    sort(A,A+n);
    int x=INT_MAX;
    for(int i=0;i<n-1;i++)
        if (A[i+1]-A[i]<x)
            x=A[i+1]-A[i];
   return x;
}

int main()
{
    int x,i,j,k,t,n,m,b1,b2,br=0;
    scanf("%d",&t);
    for(i=0;i<t;i++)
    {
        bool provera=true;
        scanf("%d%d",&n,&m);
        for(j=0;j<n;j++)
            scanf("%lld",&A[j]);
        x=razlika(A,n);
        for(k=0;k<m;k++)
        {
            scanf("%lld",&B[k]);
            b1=A[0] % x;
            b2=B[k] % x;
            if(b1==b2)
                provera=false;
        }
        if(provera)
            C[br++]=1;
        else
            C[br++]=0;
    }
    for(i=0;i<br;i++)
        printf("%d\n",C[i]);
    return 0;
}